<template>
    <div>
        <Section
            v-for="(block, index) in blocks"
            :key="index"
            :is-open="block.isOpen"
            :index="index"
            :title="block.title"
            @toggleOpen="toggleOpen"
        >
            <component
                :is="block.component"
                :isOpen="block.isOpen"
            />
        </Section>
    </div>
</template>

<script>
  import { mapActions } from 'vuex';
  export default {
    name: "Constants",
    data() {
        return {
            blocks: [
                {title: 'ЛОГИСТИЧЕСКОЕ ПЛЕЧО', isOpen: true, component: 'LogisticLeverage'},
                {title: 'СООТВЕТСТВИЕ СКЛАДОВ WILDBERRIES', isOpen: true, component: 'WBStorage'},
                {title: 'СООТВЕТСТВИЕ СКЛАДОВ OZON', isOpen: true, component: 'OzonStorage'}
            ],
        }
    },
    mounted() {
      this.changePreloaderState(true, 'Загрузка данных о константах');
      this.$store.dispatch('getAll')
      .catch(response => {
        let message = '';
        if ('message' in response) message = response.message;
        this.addToast({
          toastInfo: message,
          isVisibleToast: true,
        });
      })
	 .finally(() => this.changePreloaderState(false, ''))

    },
    methods: {
      toggleOpen(index) {
        this.blocks[index].isOpen = !this.blocks[index].isOpen
      },
      ...mapActions({addToast: 'toast/addToast'})
    },
}
</script>
